/*   FILE: simple-daap-record.vala -- A DAAPRecord implementation in Vala
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 27 November 2013
 *
 * Copyright (c) 2010 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

private class SimpleDAAPRecord : GLib.Object, DMAP.Record, DAAP.Record {
	public int64  filesize    { get; set; default = 0; }
	public int    rating      { get; set; default = 0; }
	public int    bitrate     { get; set; default = 0; }
	public int    firstseen   { get; set; default = 0; }
	public int    mtime       { get; set; default = 0; }
	public int    disc        { get; set; default = 0; }
	public int    duration    { get; set; default = 0; }
	public int    track       { get; set; default = 0; }
	public int    year        { get; set; default = 0; }
	public bool   has_video   { get; set; default = false; }
	public string location    { get; set; default = "Unknown"; }
	public string title       { get; set; default = "Unknown"; }
	public string format      { get; set; default = "Unknown"; }
	public string real_format { get; set; default = "Unknown"; }
	public string songalbum   { get; set; default = "Unknown"; }
	public string songartist  { get; set; default = "Unknown"; }
	public string genre       { get; set; default = "Unknown"; }

	public unowned bool set_from_blob (GLib.ByteArray blob) {
		GLib.error ("set_from_blob not implemented");
	}

	public unowned GLib.ByteArray to_blob () {
		GLib.error ("to_blob not implemented");
	}

	public unowned GLib.InputStream read () {
		GLib.error ("read not implemented");
	}

	public bool itunes_compat () {
		if ("mp3" == format) {
			return true;
		} else {
			return false;
		}
	}
}

private class SimpleDAAPRecordFactory : GLib.Object, DMAP.RecordFactory {
	public DMAP.Record create (void* user_data) {
		return new SimpleDAAPRecord ();
	}
}
