/* state-choose-service.c generated by valac 0.22.1, the Vala compiler
 * generated from state-choose-service.vala, do not modify */

/*   FILE: state-choose-service.vala -- A state machine implementing lcddaap's menu
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 01 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <libdmapsharing/dmap.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_STATE (state_get_type ())
#define STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE, State))
#define STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE, StateClass))
#define IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE))
#define IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE))
#define STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE, StateClass))

typedef struct _State State;
typedef struct _StateClass StateClass;
typedef struct _StatePrivate StatePrivate;

#define TYPE_LCD_PLAYER (lcd_player_get_type ())
#define LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LCD_PLAYER, LCDPlayer))
#define LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LCD_PLAYER, LCDPlayerClass))
#define IS_LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LCD_PLAYER))
#define IS_LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LCD_PLAYER))
#define LCD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LCD_PLAYER, LCDPlayerClass))

typedef struct _LCDPlayer LCDPlayer;
typedef struct _LCDPlayerClass LCDPlayerClass;

#define TYPE_STATE_CHOOSE_SERVICE (state_choose_service_get_type ())
#define STATE_CHOOSE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_CHOOSE_SERVICE, StateChooseService))
#define STATE_CHOOSE_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_CHOOSE_SERVICE, StateChooseServiceClass))
#define IS_STATE_CHOOSE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_CHOOSE_SERVICE))
#define IS_STATE_CHOOSE_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_CHOOSE_SERVICE))
#define STATE_CHOOSE_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_CHOOSE_SERVICE, StateChooseServiceClass))

typedef struct _StateChooseService StateChooseService;
typedef struct _StateChooseServiceClass StateChooseServiceClass;
typedef struct _StateChooseServicePrivate StateChooseServicePrivate;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_STATE_CONNECTING (state_connecting_get_type ())
#define STATE_CONNECTING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_CONNECTING, StateConnecting))
#define STATE_CONNECTING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_CONNECTING, StateConnectingClass))
#define IS_STATE_CONNECTING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_CONNECTING))
#define IS_STATE_CONNECTING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_CONNECTING))
#define STATE_CONNECTING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_CONNECTING, StateConnectingClass))

typedef struct _StateConnecting StateConnecting;
typedef struct _StateConnectingClass StateConnectingClass;

struct _State {
	GObject parent_instance;
	StatePrivate * priv;
	LCDPlayer* player;
};

struct _StateClass {
	GObjectClass parent_class;
	void (*print_selected) (State* self);
	void (*next) (State* self);
	void (*previous) (State* self);
	State* (*transition) (State* self);
};

struct _StateChooseService {
	State parent_instance;
	StateChooseServicePrivate * priv;
};

struct _StateChooseServiceClass {
	StateClass parent_class;
};

struct _StateChooseServicePrivate {
	GMainLoop* loop;
	GeeArrayList* services;
	gint current;
};


static gpointer state_choose_service_parent_class = NULL;

GType state_get_type (void) G_GNUC_CONST;
gpointer lcd_player_ref (gpointer instance);
void lcd_player_unref (gpointer instance);
GParamSpec* param_spec_lcd_player (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_lcd_player (GValue* value, gpointer v_object);
void value_take_lcd_player (GValue* value, gpointer v_object);
gpointer value_get_lcd_player (const GValue* value);
GType lcd_player_get_type (void) G_GNUC_CONST;
GType state_choose_service_get_type (void) G_GNUC_CONST;
#define STATE_CHOOSE_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATE_CHOOSE_SERVICE, StateChooseServicePrivate))
enum  {
	STATE_CHOOSE_SERVICE_DUMMY_PROPERTY
};
StateChooseService* state_choose_service_new (GMainLoop* loop, LCDPlayer* player, GeeArrayList* services);
StateChooseService* state_choose_service_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, GeeArrayList* services);
State* state_construct (GType object_type);
void state_print_selected (State* self);
static void state_choose_service_real_print_selected (State* base);
void state_output (State* self, const gchar* str);
static void state_choose_service_real_next (State* base);
static void state_choose_service_real_previous (State* base);
static State* state_choose_service_real_transition (State* base);
StateConnecting* state_connecting_new (GMainLoop* loop, LCDPlayer* player, DMAPMdnsBrowserService* service);
StateConnecting* state_connecting_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, DMAPMdnsBrowserService* service);
GType state_connecting_get_type (void) G_GNUC_CONST;
static void state_choose_service_finalize (GObject* obj);


static gpointer _g_main_loop_ref0 (gpointer self) {
	return self ? g_main_loop_ref (self) : NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


StateChooseService* state_choose_service_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, GeeArrayList* services) {
	StateChooseService * self = NULL;
	GMainLoop* _tmp0_ = NULL;
	GMainLoop* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	LCDPlayer* _tmp4_ = NULL;
	g_return_val_if_fail (loop != NULL, NULL);
	g_return_val_if_fail (player != NULL, NULL);
	g_return_val_if_fail (services != NULL, NULL);
	self = (StateChooseService*) state_construct (object_type);
	_tmp0_ = loop;
	_tmp1_ = _g_main_loop_ref0 (_tmp0_);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp1_;
	_tmp2_ = services;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->services);
	self->priv->services = _tmp3_;
	_tmp4_ = player;
	((State*) self)->player = _tmp4_;
	state_print_selected ((State*) self);
	return self;
}


StateChooseService* state_choose_service_new (GMainLoop* loop, LCDPlayer* player, GeeArrayList* services) {
	return state_choose_service_construct (TYPE_STATE_CHOOSE_SERVICE, loop, player, services);
}


static void state_choose_service_real_print_selected (State* base) {
	StateChooseService * self;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	self = (StateChooseService*) base;
	_tmp0_ = self->priv->services;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (0 == _tmp2_) {
		state_output ((State*) self, "No share found");
	} else {
		GeeArrayList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gpointer _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp3_ = self->priv->services;
		_tmp4_ = self->priv->current;
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, _tmp4_);
		_tmp6_ = ((DMAPMdnsBrowserService*) _tmp5_)->service_name;
		state_output ((State*) self, _tmp6_);
	}
}


static void state_choose_service_real_next (State* base) {
	StateChooseService * self;
	gint _tmp0_ = 0;
	GeeArrayList* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp8_ = 0;
	self = (StateChooseService*) base;
	_tmp1_ = self->priv->services;
	_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ > 0) {
		gint _tmp4_ = 0;
		GeeArrayList* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp4_ = self->priv->current;
		_tmp5_ = self->priv->services;
		_tmp6_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = (_tmp4_ + 1) % _tmp7_;
	} else {
		_tmp0_ = 0;
	}
	_tmp8_ = _tmp0_;
	self->priv->current = _tmp8_;
	state_print_selected ((State*) self);
}


static void state_choose_service_real_previous (State* base) {
	StateChooseService * self;
	gint _tmp0_ = 0;
	GeeArrayList* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp11_ = 0;
	self = (StateChooseService*) base;
	_tmp1_ = self->priv->services;
	_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ > 0) {
		gint _tmp4_ = 0;
		GeeArrayList* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		GeeArrayList* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		_tmp4_ = self->priv->current;
		_tmp5_ = self->priv->services;
		_tmp6_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = self->priv->services;
		_tmp9_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = ((_tmp4_ + _tmp7_) - 1) % _tmp10_;
	} else {
		_tmp0_ = 0;
	}
	_tmp11_ = _tmp0_;
	self->priv->current = _tmp11_;
	state_print_selected ((State*) self);
}


static State* state_choose_service_real_transition (State* base) {
	StateChooseService * self;
	State* result = NULL;
	DMAPMdnsBrowserService* service = NULL;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gpointer _tmp2_ = NULL;
	GMainLoop* _tmp3_ = NULL;
	LCDPlayer* _tmp4_ = NULL;
	StateConnecting* _tmp5_ = NULL;
	self = (StateChooseService*) base;
	_tmp0_ = self->priv->services;
	_tmp1_ = self->priv->current;
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp1_);
	service = (DMAPMdnsBrowserService*) _tmp2_;
	_tmp3_ = self->priv->loop;
	_tmp4_ = ((State*) self)->player;
	_tmp5_ = state_connecting_new (_tmp3_, _tmp4_, service);
	result = (State*) _tmp5_;
	return result;
}


static void state_choose_service_class_init (StateChooseServiceClass * klass) {
	state_choose_service_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StateChooseServicePrivate));
	STATE_CLASS (klass)->print_selected = state_choose_service_real_print_selected;
	STATE_CLASS (klass)->next = state_choose_service_real_next;
	STATE_CLASS (klass)->previous = state_choose_service_real_previous;
	STATE_CLASS (klass)->transition = state_choose_service_real_transition;
	G_OBJECT_CLASS (klass)->finalize = state_choose_service_finalize;
}


static void state_choose_service_instance_init (StateChooseService * self) {
	self->priv = STATE_CHOOSE_SERVICE_GET_PRIVATE (self);
	self->priv->current = 0;
}


static void state_choose_service_finalize (GObject* obj) {
	StateChooseService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATE_CHOOSE_SERVICE, StateChooseService);
	_g_main_loop_unref0 (self->priv->loop);
	_g_object_unref0 (self->priv->services);
	G_OBJECT_CLASS (state_choose_service_parent_class)->finalize (obj);
}


GType state_choose_service_get_type (void) {
	static volatile gsize state_choose_service_type_id__volatile = 0;
	if (g_once_init_enter (&state_choose_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StateChooseServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) state_choose_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StateChooseService), 0, (GInstanceInitFunc) state_choose_service_instance_init, NULL };
		GType state_choose_service_type_id;
		state_choose_service_type_id = g_type_register_static (TYPE_STATE, "StateChooseService", &g_define_type_info, 0);
		g_once_init_leave (&state_choose_service_type_id__volatile, state_choose_service_type_id);
	}
	return state_choose_service_type_id__volatile;
}



