/* state-connecting.c generated by valac 0.22.1, the Vala compiler
 * generated from state-connecting.vala, do not modify */

/*   FILE: state-connecting.vala -- A state machine implementing lcddaap's menu
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 14 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <libdmapsharing/dmap.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_STATE (state_get_type ())
#define STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE, State))
#define STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE, StateClass))
#define IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE))
#define IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE))
#define STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE, StateClass))

typedef struct _State State;
typedef struct _StateClass StateClass;
typedef struct _StatePrivate StatePrivate;

#define TYPE_LCD_PLAYER (lcd_player_get_type ())
#define LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LCD_PLAYER, LCDPlayer))
#define LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LCD_PLAYER, LCDPlayerClass))
#define IS_LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LCD_PLAYER))
#define IS_LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LCD_PLAYER))
#define LCD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LCD_PLAYER, LCDPlayerClass))

typedef struct _LCDPlayer LCDPlayer;
typedef struct _LCDPlayerClass LCDPlayerClass;

#define TYPE_STATE_CONNECTING (state_connecting_get_type ())
#define STATE_CONNECTING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_CONNECTING, StateConnecting))
#define STATE_CONNECTING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_CONNECTING, StateConnectingClass))
#define IS_STATE_CONNECTING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_CONNECTING))
#define IS_STATE_CONNECTING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_CONNECTING))
#define STATE_CONNECTING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_CONNECTING, StateConnectingClass))

typedef struct _StateConnecting StateConnecting;
typedef struct _StateConnectingClass StateConnectingClass;
typedef struct _StateConnectingPrivate StateConnectingPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _State {
	GObject parent_instance;
	StatePrivate * priv;
	LCDPlayer* player;
};

struct _StateClass {
	GObjectClass parent_class;
	void (*print_selected) (State* self);
	void (*next) (State* self);
	void (*previous) (State* self);
	State* (*transition) (State* self);
};

struct _StateConnecting {
	State parent_instance;
	StateConnectingPrivate * priv;
};

struct _StateConnectingClass {
	StateClass parent_class;
};

struct _StateConnectingPrivate {
	DMAPMdnsBrowserService* service;
};


static gpointer state_connecting_parent_class = NULL;

GType state_get_type (void) G_GNUC_CONST;
gpointer lcd_player_ref (gpointer instance);
void lcd_player_unref (gpointer instance);
GParamSpec* param_spec_lcd_player (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_lcd_player (GValue* value, gpointer v_object);
void value_take_lcd_player (GValue* value, gpointer v_object);
gpointer value_get_lcd_player (const GValue* value);
GType lcd_player_get_type (void) G_GNUC_CONST;
GType state_connecting_get_type (void) G_GNUC_CONST;
#define STATE_CONNECTING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATE_CONNECTING, StateConnectingPrivate))
enum  {
	STATE_CONNECTING_DUMMY_PROPERTY
};
StateConnecting* state_connecting_new (GMainLoop* loop, LCDPlayer* player, DMAPMdnsBrowserService* service);
StateConnecting* state_connecting_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, DMAPMdnsBrowserService* service);
State* state_construct (GType object_type);
void state_print_selected (State* self);
void lcd_player_connect (LCDPlayer* self, DMAPMdnsBrowserService* service);
static void state_connecting_real_print_selected (State* base);
void state_output (State* self, const gchar* str);
static void state_connecting_real_next (State* base);
static void state_connecting_real_previous (State* base);
static State* state_connecting_real_transition (State* base);
static void state_connecting_finalize (GObject* obj);


StateConnecting* state_connecting_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, DMAPMdnsBrowserService* service) {
	StateConnecting * self = NULL;
	DMAPMdnsBrowserService* _tmp0_ = NULL;
	LCDPlayer* _tmp1_ = NULL;
	DMAPMdnsBrowserService* _tmp2_ = NULL;
	g_return_val_if_fail (loop != NULL, NULL);
	g_return_val_if_fail (player != NULL, NULL);
	g_return_val_if_fail (service != NULL, NULL);
	self = (StateConnecting*) state_construct (object_type);
	_tmp0_ = service;
	self->priv->service = _tmp0_;
	state_print_selected ((State*) self);
	_tmp1_ = player;
	_tmp2_ = service;
	lcd_player_connect (_tmp1_, _tmp2_);
	return self;
}


StateConnecting* state_connecting_new (GMainLoop* loop, LCDPlayer* player, DMAPMdnsBrowserService* service) {
	return state_connecting_construct (TYPE_STATE_CONNECTING, loop, player, service);
}


static void state_connecting_real_print_selected (State* base) {
	StateConnecting * self;
	DMAPMdnsBrowserService* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	self = (StateConnecting*) base;
	_tmp0_ = self->priv->service;
	_tmp1_ = _tmp0_->service_name;
	_tmp2_ = g_strconcat ("Connecting to ", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "...", NULL);
	_tmp5_ = _tmp4_;
	state_output ((State*) self, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
}


static void state_connecting_real_next (State* base) {
	StateConnecting * self;
	self = (StateConnecting*) base;
}


static void state_connecting_real_previous (State* base) {
	StateConnecting * self;
	self = (StateConnecting*) base;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static State* state_connecting_real_transition (State* base) {
	StateConnecting * self;
	State* result = NULL;
	State* _tmp0_ = NULL;
	self = (StateConnecting*) base;
	_tmp0_ = _g_object_ref0 ((State*) self);
	result = _tmp0_;
	return result;
}


static void state_connecting_class_init (StateConnectingClass * klass) {
	state_connecting_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StateConnectingPrivate));
	STATE_CLASS (klass)->print_selected = state_connecting_real_print_selected;
	STATE_CLASS (klass)->next = state_connecting_real_next;
	STATE_CLASS (klass)->previous = state_connecting_real_previous;
	STATE_CLASS (klass)->transition = state_connecting_real_transition;
	G_OBJECT_CLASS (klass)->finalize = state_connecting_finalize;
}


static void state_connecting_instance_init (StateConnecting * self) {
	self->priv = STATE_CONNECTING_GET_PRIVATE (self);
}


static void state_connecting_finalize (GObject* obj) {
	StateConnecting * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATE_CONNECTING, StateConnecting);
	G_OBJECT_CLASS (state_connecting_parent_class)->finalize (obj);
}


GType state_connecting_get_type (void) {
	static volatile gsize state_connecting_type_id__volatile = 0;
	if (g_once_init_enter (&state_connecting_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StateConnectingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) state_connecting_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StateConnecting), 0, (GInstanceInitFunc) state_connecting_instance_init, NULL };
		GType state_connecting_type_id;
		state_connecting_type_id = g_type_register_static (TYPE_STATE, "StateConnecting", &g_define_type_info, 0);
		g_once_init_leave (&state_connecting_type_id__volatile, state_connecting_type_id);
	}
	return state_connecting_type_id__volatile;
}



