/* state-play.c generated by valac 0.22.1, the Vala compiler
 * generated from state-play.vala, do not modify */

/*   FILE: state-play.vala -- A state machine implementing lcddaap's menu
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 01 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <libdmapsharing/dmap.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <stdio.h>


#define TYPE_STATE (state_get_type ())
#define STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE, State))
#define STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE, StateClass))
#define IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE))
#define IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE))
#define STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE, StateClass))

typedef struct _State State;
typedef struct _StateClass StateClass;
typedef struct _StatePrivate StatePrivate;

#define TYPE_LCD_PLAYER (lcd_player_get_type ())
#define LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LCD_PLAYER, LCDPlayer))
#define LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LCD_PLAYER, LCDPlayerClass))
#define IS_LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LCD_PLAYER))
#define IS_LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LCD_PLAYER))
#define LCD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LCD_PLAYER, LCDPlayerClass))

typedef struct _LCDPlayer LCDPlayer;
typedef struct _LCDPlayerClass LCDPlayerClass;

#define TYPE_STATE_PLAY (state_play_get_type ())
#define STATE_PLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_PLAY, StatePlay))
#define STATE_PLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_PLAY, StatePlayClass))
#define IS_STATE_PLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_PLAY))
#define IS_STATE_PLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_PLAY))
#define STATE_PLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_PLAY, StatePlayClass))

typedef struct _StatePlay StatePlay;
typedef struct _StatePlayClass StatePlayClass;
typedef struct _StatePlayPrivate StatePlayPrivate;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SIMPLE_DAAP_RECORD (simple_daap_record_get_type ())
#define SIMPLE_DAAP_RECORD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SIMPLE_DAAP_RECORD, SimpleDAAPRecord))
#define SIMPLE_DAAP_RECORD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SIMPLE_DAAP_RECORD, SimpleDAAPRecordClass))
#define IS_SIMPLE_DAAP_RECORD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SIMPLE_DAAP_RECORD))
#define IS_SIMPLE_DAAP_RECORD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SIMPLE_DAAP_RECORD))
#define SIMPLE_DAAP_RECORD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SIMPLE_DAAP_RECORD, SimpleDAAPRecordClass))

typedef struct _SimpleDAAPRecord SimpleDAAPRecord;
typedef struct _SimpleDAAPRecordClass SimpleDAAPRecordClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _LCDPlayerPrivate LCDPlayerPrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _State {
	GObject parent_instance;
	StatePrivate * priv;
	LCDPlayer* player;
};

struct _StateClass {
	GObjectClass parent_class;
	void (*print_selected) (State* self);
	void (*next) (State* self);
	void (*previous) (State* self);
	State* (*transition) (State* self);
};

struct _StatePlay {
	State parent_instance;
	StatePlayPrivate * priv;
};

struct _StatePlayClass {
	StateClass parent_class;
};

struct _StatePlayPrivate {
	GMainLoop* loop;
	GeeArrayList* playlist;
	gint current;
	DMAPDb* db;
};

struct _LCDPlayer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LCDPlayerPrivate * priv;
	GstElement* element;
};

struct _LCDPlayerClass {
	GTypeClass parent_class;
	void (*finalize) (LCDPlayer *self);
};


static gpointer state_play_parent_class = NULL;

GType state_get_type (void) G_GNUC_CONST;
gpointer lcd_player_ref (gpointer instance);
void lcd_player_unref (gpointer instance);
GParamSpec* param_spec_lcd_player (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_lcd_player (GValue* value, gpointer v_object);
void value_take_lcd_player (GValue* value, gpointer v_object);
gpointer value_get_lcd_player (const GValue* value);
GType lcd_player_get_type (void) G_GNUC_CONST;
GType state_play_get_type (void) G_GNUC_CONST;
#define STATE_PLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATE_PLAY, StatePlayPrivate))
enum  {
	STATE_PLAY_DUMMY_PROPERTY
};
StatePlay* state_play_new (GMainLoop* loop, LCDPlayer* player, DMAPDb* db, GeeArrayList* playlist);
StatePlay* state_play_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, DMAPDb* db, GeeArrayList* playlist);
State* state_construct (GType object_type);
void state_print_selected (State* self);
static void state_play_real_print_selected (State* base);
void state_output (State* self, const gchar* str);
GType simple_daap_record_get_type (void) G_GNUC_CONST;
const gchar* simple_daap_record_get_title (SimpleDAAPRecord* self);
static gboolean state_play_bus_callback (StatePlay* self, GstBus* bus, GstMessage* message);
static void state_play_real_next (State* base);
static void state_play_real_previous (State* base);
static void state_play_play (StatePlay* self, guint id);
const gchar* simple_daap_record_get_location (SimpleDAAPRecord* self);
static inline void _dynamic_set_uri0 (GstElement* obj, const gchar* value);
static gboolean _state_play_bus_callback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self);
void state_register_handlers (State* self);
static State* state_play_real_transition (State* base);
static void state_play_finalize (GObject* obj);


static gpointer _g_main_loop_ref0 (gpointer self) {
	return self ? g_main_loop_ref (self) : NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


StatePlay* state_play_construct (GType object_type, GMainLoop* loop, LCDPlayer* player, DMAPDb* db, GeeArrayList* playlist) {
	StatePlay * self = NULL;
	GMainLoop* _tmp0_ = NULL;
	GMainLoop* _tmp1_ = NULL;
	LCDPlayer* _tmp2_ = NULL;
	DMAPDb* _tmp3_ = NULL;
	DMAPDb* _tmp4_ = NULL;
	GeeArrayList* _tmp5_ = NULL;
	GeeArrayList* _tmp6_ = NULL;
	g_return_val_if_fail (loop != NULL, NULL);
	g_return_val_if_fail (player != NULL, NULL);
	g_return_val_if_fail (db != NULL, NULL);
	g_return_val_if_fail (playlist != NULL, NULL);
	self = (StatePlay*) state_construct (object_type);
	_tmp0_ = loop;
	_tmp1_ = _g_main_loop_ref0 (_tmp0_);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp1_;
	_tmp2_ = player;
	((State*) self)->player = _tmp2_;
	_tmp3_ = db;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->db);
	self->priv->db = _tmp4_;
	_tmp5_ = playlist;
	_tmp6_ = _g_object_ref0 (_tmp5_);
	_g_object_unref0 (self->priv->playlist);
	self->priv->playlist = _tmp6_;
	state_print_selected ((State*) self);
	return self;
}


StatePlay* state_play_new (GMainLoop* loop, LCDPlayer* player, DMAPDb* db, GeeArrayList* playlist) {
	return state_play_construct (TYPE_STATE_PLAY, loop, player, db, playlist);
}


static void state_play_real_print_selected (State* base) {
	StatePlay * self;
	gint _tmp0_ = 0;
	self = (StatePlay*) base;
	_tmp0_ = self->priv->current;
	if (0 == _tmp0_) {
		state_output ((State*) self, "Play all songs");
	} else {
		DMAPDb* _tmp1_ = NULL;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gpointer _tmp4_ = NULL;
		DMAPRecord* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		_tmp1_ = self->priv->db;
		_tmp2_ = self->priv->playlist;
		_tmp3_ = self->priv->current;
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, _tmp3_ - 1);
		_tmp5_ = dmap_db_lookup_by_id (_tmp1_, (guint) ((gint) ((gintptr) _tmp4_)));
		_tmp6_ = simple_daap_record_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_SIMPLE_DAAP_RECORD, SimpleDAAPRecord));
		_tmp7_ = _tmp6_;
		state_output ((State*) self, _tmp7_);
	}
}


static gboolean state_play_bus_callback (StatePlay* self, GstBus* bus, GstMessage* message) {
	gboolean result = FALSE;
	GstMessage* _tmp0_ = NULL;
	GstMessageType _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message;
	_tmp1_ = _tmp0_->type;
	switch (_tmp1_) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GstMessage* _tmp2_ = NULL;
			GError* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			FILE* _tmp5_ = NULL;
			GError* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			GMainLoop* _tmp8_ = NULL;
			_tmp2_ = message;
			gst_message_parse_error (_tmp2_, &_tmp3_, &_tmp4_);
			_g_error_free0 (err);
			err = _tmp3_;
			_g_free0 (debug);
			debug = _tmp4_;
			_tmp5_ = stderr;
			_tmp6_ = err;
			_tmp7_ = _tmp6_->message;
			fprintf (_tmp5_, "Error: %s\n", _tmp7_);
			_tmp8_ = self->priv->loop;
			g_main_loop_quit (_tmp8_);
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_EOS:
		{
			GMainLoop* _tmp9_ = NULL;
			_tmp9_ = self->priv->loop;
			g_main_loop_quit (_tmp9_);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}


static void state_play_real_next (State* base) {
	StatePlay * self;
	gint _tmp0_ = 0;
	GeeArrayList* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	self = (StatePlay*) base;
	_tmp0_ = self->priv->current;
	_tmp1_ = self->priv->playlist;
	_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	self->priv->current = (_tmp0_ + 1) % (_tmp3_ + 1);
	state_print_selected ((State*) self);
}


static void state_play_real_previous (State* base) {
	StatePlay * self;
	gint _tmp0_ = 0;
	GeeArrayList* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GeeArrayList* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	self = (StatePlay*) base;
	_tmp0_ = self->priv->current;
	_tmp1_ = self->priv->playlist;
	_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->playlist;
	_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
	_tmp6_ = _tmp5_;
	self->priv->current = (_tmp0_ + _tmp3_) % (_tmp6_ + 1);
	state_print_selected ((State*) self);
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static inline void _dynamic_set_uri0 (GstElement* obj, const gchar* value) {
	g_object_set (obj, "uri", value, NULL);
}


static gboolean _state_play_bus_callback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self) {
	gboolean result;
	result = state_play_bus_callback (self, bus, message);
	return result;
}


static void state_play_play (StatePlay* self, guint id) {
	SimpleDAAPRecord* record = NULL;
	DMAPDb* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	DMAPRecord* _tmp2_ = NULL;
	SimpleDAAPRecord* _tmp3_ = NULL;
	GString* builder = NULL;
	GString* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	LCDPlayer* _tmp13_ = NULL;
	GstElement* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	GstBus* bus = NULL;
	LCDPlayer* _tmp16_ = NULL;
	GstElement* _tmp17_ = NULL;
	GstBus* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	GMainLoop* _tmp23_ = NULL;
	LCDPlayer* _tmp24_ = NULL;
	GstElement* _tmp25_ = NULL;
	GMainLoop* _tmp26_ = NULL;
	LCDPlayer* _tmp27_ = NULL;
	GstElement* _tmp28_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = id;
	_tmp2_ = dmap_db_lookup_by_id (_tmp0_, _tmp1_);
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SIMPLE_DAAP_RECORD, SimpleDAAPRecord));
	record = _tmp3_;
	_tmp4_ = g_string_new ("");
	builder = _tmp4_;
	_tmp5_ = simple_daap_record_get_location (record);
	_tmp6_ = _tmp5_;
	_tmp7_ = simple_daap_record_get_location (record);
	_tmp8_ = _tmp7_;
	_tmp9_ = strlen (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = string_substring (_tmp6_, (glong) 4, (glong) (_tmp10_ - 4));
	_tmp12_ = _tmp11_;
	g_string_append (builder, _tmp12_);
	_g_free0 (_tmp12_);
	g_string_prepend (builder, "http");
	_tmp13_ = ((State*) self)->player;
	_tmp14_ = _tmp13_->element;
	_tmp15_ = builder->str;
	_dynamic_set_uri0 (_tmp14_, _tmp15_);
	_tmp16_ = ((State*) self)->player;
	_tmp17_ = _tmp16_->element;
	_tmp18_ = gst_element_get_bus (_tmp17_);
	bus = _tmp18_;
	gst_bus_add_watch_full (bus, G_PRIORITY_DEFAULT, _state_play_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	_tmp19_ = simple_daap_record_get_title (record);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat ("Playing ", _tmp20_, NULL);
	_tmp22_ = _tmp21_;
	state_output ((State*) self, _tmp22_);
	_g_free0 (_tmp22_);
	_tmp23_ = self->priv->loop;
	g_main_loop_quit (_tmp23_);
	_tmp24_ = ((State*) self)->player;
	_tmp25_ = _tmp24_->element;
	gst_element_set_state (_tmp25_, GST_STATE_PLAYING);
	state_register_handlers ((State*) self);
	_tmp26_ = self->priv->loop;
	g_main_loop_run (_tmp26_);
	_tmp27_ = ((State*) self)->player;
	_tmp28_ = _tmp27_->element;
	gst_element_set_state (_tmp28_, GST_STATE_NULL);
	_g_object_unref0 (bus);
	_g_string_free0 (builder);
	_g_object_unref0 (record);
}


static State* state_play_real_transition (State* base) {
	StatePlay * self;
	State* result = NULL;
	gint _tmp2_ = 0;
	GMainLoop* _tmp18_ = NULL;
	State* _tmp19_ = NULL;
	self = (StatePlay*) base;
	if (NULL != state_play_play) {
		LCDPlayer* _tmp0_ = NULL;
		GstElement* _tmp1_ = NULL;
		_tmp0_ = ((State*) self)->player;
		_tmp1_ = _tmp0_->element;
		gst_element_set_state (_tmp1_, GST_STATE_NULL);
	}
	_tmp2_ = self->priv->current;
	if (0 == _tmp2_) {
		{
			GeeArrayList* _i_list = NULL;
			GeeArrayList* _tmp3_ = NULL;
			GeeArrayList* _tmp4_ = NULL;
			gint _i_size = 0;
			GeeArrayList* _tmp5_ = NULL;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _i_index = 0;
			_tmp3_ = self->priv->playlist;
			_tmp4_ = _g_object_ref0 (_tmp3_);
			_i_list = _tmp4_;
			_tmp5_ = _i_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_i_size = _tmp7_;
			_i_index = -1;
			while (TRUE) {
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint i = 0;
				GeeArrayList* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gpointer _tmp13_ = NULL;
				gint _tmp14_ = 0;
				_tmp8_ = _i_index;
				_i_index = _tmp8_ + 1;
				_tmp9_ = _i_index;
				_tmp10_ = _i_size;
				if (!(_tmp9_ < _tmp10_)) {
					break;
				}
				_tmp11_ = _i_list;
				_tmp12_ = _i_index;
				_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
				i = (gint) ((gintptr) _tmp13_);
				_tmp14_ = i;
				state_play_play (self, (guint) _tmp14_);
			}
			_g_object_unref0 (_i_list);
		}
	} else {
		GeeArrayList* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		gpointer _tmp17_ = NULL;
		_tmp15_ = self->priv->playlist;
		_tmp16_ = self->priv->current;
		_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_ - 1);
		state_play_play (self, (guint) ((gint) ((gintptr) _tmp17_)));
	}
	_tmp18_ = self->priv->loop;
	g_main_loop_run (_tmp18_);
	_tmp19_ = _g_object_ref0 ((State*) self);
	result = _tmp19_;
	return result;
}


static void state_play_class_init (StatePlayClass * klass) {
	state_play_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StatePlayPrivate));
	STATE_CLASS (klass)->print_selected = state_play_real_print_selected;
	STATE_CLASS (klass)->next = state_play_real_next;
	STATE_CLASS (klass)->previous = state_play_real_previous;
	STATE_CLASS (klass)->transition = state_play_real_transition;
	G_OBJECT_CLASS (klass)->finalize = state_play_finalize;
}


static void state_play_instance_init (StatePlay * self) {
	self->priv = STATE_PLAY_GET_PRIVATE (self);
	self->priv->current = 0;
}


static void state_play_finalize (GObject* obj) {
	StatePlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATE_PLAY, StatePlay);
	_g_main_loop_unref0 (self->priv->loop);
	_g_object_unref0 (self->priv->playlist);
	_g_object_unref0 (self->priv->db);
	G_OBJECT_CLASS (state_play_parent_class)->finalize (obj);
}


GType state_play_get_type (void) {
	static volatile gsize state_play_type_id__volatile = 0;
	if (g_once_init_enter (&state_play_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StatePlayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) state_play_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatePlay), 0, (GInstanceInitFunc) state_play_instance_init, NULL };
		GType state_play_type_id;
		state_play_type_id = g_type_register_static (TYPE_STATE, "StatePlay", &g_define_type_info, 0);
		g_once_init_leave (&state_play_type_id__volatile, state_play_type_id);
	}
	return state_play_type_id__volatile;
}



